Index: new-game.cpp
===================================================================
--- new-game.cpp	(revision 81f28c061f7eb8c79fb08d3263447f4c9142a249)
+++ new-game.cpp	(revision 20e00202b2e4c748de424a4416122a030223f4d6)
@@ -435,55 +435,141 @@
        0.5f,  0.3f, -2.0f,
 
-       // top mid
-       -0.25f,  0.3f, -3.0f,
-       -0.5f,  0.3f, -2.0f,
-        0.5f,  0.3f, -2.0f,
-       -0.25f,  0.3f, -3.0f,
-        0.5f,  0.3f, -2.0f,
-        0.25f,  0.3f, -3.0f,
-
-       // top front
-       -0.25f,  0.3f, -3.0f,
-        0.25f,  0.3f, -3.0f,
-        0.0f,  0.0f, -3.5f,
-
-       // left wing start back
-       -1.5f,  0.3f,  0.0f,
-       -1.5f,  0.0f,  0.0f,
-       -0.5f,  0.0f,  0.0f,
-       -1.5f,  0.3f,  0.0f,
-       -0.5f,  0.0f,  0.0f,
-       -0.5f,  0.3f,  0.0f,
-
-       // left wing start top
-       -0.5f,  0.3f, -0.3f,
-       -1.3f,  0.3f, -0.3f,
-       -1.5f,  0.3f,  0.0f,
-       -0.5f,  0.3f, -0.3f,
-       -1.5f,  0.3f,  0.0f,
-       -0.5f,  0.3f,  0.0f,
-
-       // left wing start front
-       -0.5f,  0.3f, -0.3f,
-       -0.5f,  0.0f, -0.3f,
-       -1.3f,  0.0f, -0.3f,
-       -0.5f,  0.3f, -0.3f,
-       -1.3f,  0.0f, -0.3f,
-       -1.3f,  0.3f, -0.3f,
-
-       // left wing end outside
-       -1.5f,  0.3f,  0.0f,
-       -2.2f,  0.15f, -0.8f,
-       -1.5f,  0.0f,  0.0f,
-
-       // left wing end top
-       -1.3f,  0.3f, -0.3f,
-       -2.2f,  0.15f, -0.8f,
-       -1.5f,  0.3f,  0.0f,
-
-       // left wing end front
-       -1.3f, 0.0f, -0.3f,
-       -2.2f, 0.15f, -0.8f,
-       -1.3f, 0.3f, -0.3f,
+      // bottom back
+      -0.5f,  0.0f,  0.0f,
+      -0.5f,  0.0f, -2.0f,
+       0.5f,  0.0f,  0.0f,
+       0.5f,  0.0f,  0.0f,
+      -0.5f,  0.0f, -2.0f,
+       0.5f,  0.0f, -2.0f,
+
+      // top mid
+      -0.25f,  0.3f, -3.0f,
+      -0.5f,  0.3f, -2.0f,
+       0.5f,  0.3f, -2.0f,
+      -0.25f,  0.3f, -3.0f,
+       0.5f,  0.3f, -2.0f,
+       0.25f,  0.3f, -3.0f,
+
+      // bottom mid
+      -0.5f,  0.0f, -2.0f,
+      -0.25f,  0.0f, -3.0f,
+       0.5f,  0.0f, -2.0f,
+       0.5f,  0.0f, -2.0f,
+      -0.25f,  0.0f, -3.0f,
+       0.25f,  0.0f, -3.0f,
+
+      // top front
+      -0.25f,  0.3f, -3.0f,
+       0.25f,  0.3f, -3.0f,
+       0.0f,  0.0f, -3.5f,
+
+      // bottom front
+       0.25f,  0.0f, -3.0f,
+      -0.25f,  0.0f, -3.0f,
+       0.0f,  0.0f, -3.5f,
+
+      // left wing start back
+      -1.5f,  0.3f,  0.0f,
+      -1.5f,  0.0f,  0.0f,
+      -0.5f,  0.0f,  0.0f,
+      -1.5f,  0.3f,  0.0f,
+      -0.5f,  0.0f,  0.0f,
+      -0.5f,  0.3f,  0.0f,
+
+      // left wing start top
+      -0.5f,  0.3f, -0.3f,
+      -1.3f,  0.3f, -0.3f,
+      -1.5f,  0.3f,  0.0f,
+      -0.5f,  0.3f, -0.3f,
+      -1.5f,  0.3f,  0.0f,
+      -0.5f,  0.3f,  0.0f,
+
+      // left wing start front
+      -0.5f,  0.3f, -0.3f,
+      -0.5f,  0.0f, -0.3f,
+      -1.3f,  0.0f, -0.3f,
+      -0.5f,  0.3f, -0.3f,
+      -1.3f,  0.0f, -0.3f,
+      -1.3f,  0.3f, -0.3f,
+
+      // left wing start bottom
+      -0.5f, 0.0f, 0.0f,
+      -1.5f, 0.0f, 0.0f,
+      -1.3f, 0.0f, -0.3f,
+      -0.5f, 0.0f, 0.0f,
+      -1.3f, 0.0f, -0.3f,
+      -0.5f, 0.0f, -0.3f,
+
+      // left wing end outside
+      -1.5f,  0.3f,  0.0f,
+      -2.2f,  0.15f, -0.8f,
+      -1.5f,  0.0f,  0.0f,
+
+      // left wing end top
+      -1.3f,  0.3f, -0.3f,
+      -2.2f,  0.15f, -0.8f,
+      -1.5f,  0.3f,  0.0f,
+
+      // left wing end front
+      -1.3f, 0.0f, -0.3f,
+      -2.2f, 0.15f, -0.8f,
+      -1.3f, 0.3f, -0.3f,
+
+      // left wing end bottom
+      -1.5f, 0.0f, 0.0f,
+      -2.2f,  0.15f, -0.8f,
+      -1.3f, 0.0f, -0.3f,
+
+      // right wing start back
+       1.5f, 0.0f, 0.0f,
+       1.5f, 0.3f, 0.0f,
+       0.5f, 0.0f, 0.0f,
+       0.5f, 0.0f, 0.0f,
+       1.5f, 0.3f, 0.0f,
+       0.5f, 0.3f, 0.0f,
+
+      // right wing start top
+       1.3f, 0.3f, -0.3f,
+       0.5f, 0.3f, -0.3f,
+       1.5f, 0.3f, 0.0f,
+       1.5f, 0.3f, 0.0f,
+       0.5f, 0.3f, -0.3f,
+       0.5f, 0.3f, 0.0f,
+
+      // right wing start front
+       0.5f,  0.0f, -0.3f,
+       0.5f,  0.3f, -0.3f,
+       1.3f,  0.0f, -0.3f,
+       1.3f,  0.0f, -0.3f,
+       0.5f,  0.3f, -0.3f,
+       1.3f,  0.3f, -0.3f,
+
+      // right wing start bottom
+       1.5f, 0.0f, 0.0f,
+       0.5f, 0.0f, 0.0f,
+       1.3f, 0.0f, -0.3f,
+       1.3f, 0.0f, -0.3f,
+       0.5f, 0.0f, 0.0f,
+       0.5f, 0.0f, -0.3f,
+
+      // right wing end outside
+       2.2f,  0.15f, -0.8f,
+       1.5f,  0.3f,  0.0f,
+       1.5f,  0.0f,  0.0f,
+
+      // right wing end top
+       2.2f,  0.15f, -0.8f,
+       1.3f,  0.3f, -0.3f,
+       1.5f,  0.3f,  0.0f,
+
+      // right wing end front
+       2.2f, 0.15f, -0.8f,
+       1.3f, 0.0f, -0.3f,
+       1.3f, 0.3f, -0.3f,
+
+      // right wing end bottom
+       2.2f,  0.15f, -0.8f,
+       1.5f, 0.0f, 0.0f,
+       1.3f, 0.0f, -0.3f,
    };
    obj.colors = {
@@ -548,22 +634,95 @@
       0.0f, 0.0f, 0.3f,
       0.0f, 0.0f, 0.3f,
-
-      0.0f, 0.0f, 0.3f,
-      0.0f, 0.0f, 0.3f,
-      0.0f, 0.0f, 0.3f,
-      0.0f, 0.0f, 0.3f,
-      0.0f, 0.0f, 0.3f,
-      0.0f, 0.0f, 0.3f,
-
-      0.0f, 0.0f, 0.3f,
-      0.0f, 0.0f, 0.3f,
-      0.0f, 0.0f, 0.3f,
-      0.0f, 0.0f, 0.3f,
-      0.0f, 0.0f, 0.3f,
-      0.0f, 0.0f, 0.3f,
-
-      0.0f, 0.0f, 0.3f,
-      0.0f, 0.0f, 0.3f,
-      0.0f, 0.0f, 0.3f,
+      0.0f, 0.0f, 0.3f,
+      0.0f, 0.0f, 0.3f,
+      0.0f, 0.0f, 0.3f,
+
+      0.0f, 0.0f, 0.3f,
+      0.0f, 0.0f, 0.3f,
+      0.0f, 0.0f, 0.3f,
+      0.0f, 0.0f, 0.3f,
+      0.0f, 0.0f, 0.3f,
+      0.0f, 0.0f, 0.3f,
+
+      0.0f, 0.0f, 0.3f,
+      0.0f, 0.0f, 0.3f,
+      0.0f, 0.0f, 0.3f,
+
+      0.0f, 0.0f, 0.3f,
+      0.0f, 0.0f, 0.3f,
+      0.0f, 0.0f, 0.3f,
+
+      0.0f, 0.0f, 0.3f,
+      0.0f, 0.0f, 0.3f,
+      0.0f, 0.0f, 0.3f,
+      0.0f, 0.0f, 0.3f,
+      0.0f, 0.0f, 0.3f,
+      0.0f, 0.0f, 0.3f,
+
+      0.0f, 0.0f, 0.3f,
+      0.0f, 0.0f, 0.3f,
+      0.0f, 0.0f, 0.3f,
+      0.0f, 0.0f, 0.3f,
+      0.0f, 0.0f, 0.3f,
+      0.0f, 0.0f, 0.3f,
+
+      0.0f, 0.0f, 0.3f,
+      0.0f, 0.0f, 0.3f,
+      0.0f, 0.0f, 0.3f,
+      0.0f, 0.0f, 0.3f,
+      0.0f, 0.0f, 0.3f,
+      0.0f, 0.0f, 0.3f,
+
+      0.0f, 0.0f, 0.3f,
+      0.0f, 0.0f, 0.3f,
+      0.0f, 0.0f, 0.3f,
+      0.0f, 0.0f, 0.3f,
+      0.0f, 0.0f, 0.3f,
+      0.0f, 0.0f, 0.3f,
+
+      0.0f, 0.0f, 0.3f,
+      0.0f, 0.0f, 0.3f,
+      0.0f, 0.0f, 0.3f,
+
+      0.0f, 0.0f, 0.3f,
+      0.0f, 0.0f, 0.3f,
+      0.0f, 0.0f, 0.3f,
+
+      0.0f, 0.0f, 0.3f,
+      0.0f, 0.0f, 0.3f,
+      0.0f, 0.0f, 0.3f,
+
+      0.0f, 0.0f, 0.3f,
+      0.0f, 0.0f, 0.3f,
+      0.0f, 0.0f, 0.3f,
+
+      0.0f, 0.0f, 0.3f,
+      0.0f, 0.0f, 0.3f,
+      0.0f, 0.0f, 0.3f,
+      0.0f, 0.0f, 0.3f,
+      0.0f, 0.0f, 0.3f,
+      0.0f, 0.0f, 0.3f,
+
+      0.0f, 0.0f, 0.3f,
+      0.0f, 0.0f, 0.3f,
+      0.0f, 0.0f, 0.3f,
+      0.0f, 0.0f, 0.3f,
+      0.0f, 0.0f, 0.3f,
+      0.0f, 0.0f, 0.3f,
+
+      0.0f, 0.0f, 0.3f,
+      0.0f, 0.0f, 0.3f,
+      0.0f, 0.0f, 0.3f,
+      0.0f, 0.0f, 0.3f,
+      0.0f, 0.0f, 0.3f,
+      0.0f, 0.0f, 0.3f,
+
+      0.0f, 0.0f, 0.3f,
+      0.0f, 0.0f, 0.3f,
+      0.0f, 0.0f, 0.3f,
+      0.0f, 0.0f, 0.3f,
+      0.0f, 0.0f, 0.3f,
+      0.0f, 0.0f, 0.3f,
+
       0.0f, 0.0f, 0.3f,
       0.0f, 0.0f, 0.3f,
@@ -643,8 +802,4 @@
       0.0f, 1.0f,
       0.0f, 0.0f,
-
-      1.0f, 1.0f,
-      0.0f, 1.0f,
-      0.0f, 0.0f,
       1.0f, 1.0f,
       0.0f, 0.0f,
@@ -661,7 +816,84 @@
       0.0f, 1.0f,
       0.0f, 0.0f,
+
+      1.0f, 1.0f,
+      0.0f, 1.0f,
+      0.0f, 0.0f,
+
+      1.0f, 1.0f,
+      0.0f, 1.0f,
+      0.0f, 0.0f,
       1.0f, 1.0f,
       0.0f, 0.0f,
       1.0f, 0.0f,
+
+      1.0f, 1.0f,
+      0.0f, 1.0f,
+      0.0f, 0.0f,
+      1.0f, 1.0f,
+      0.0f, 0.0f,
+      1.0f, 0.0f,
+
+      1.0f, 1.0f,
+      0.0f, 1.0f,
+      0.0f, 0.0f,
+      1.0f, 1.0f,
+      0.0f, 0.0f,
+      1.0f, 0.0f,
+
+      1.0f, 1.0f,
+      0.0f, 1.0f,
+      0.0f, 0.0f,
+      1.0f, 1.0f,
+      0.0f, 0.0f,
+      1.0f, 0.0f,
+
+      1.0f, 1.0f,
+      0.0f, 1.0f,
+      0.0f, 0.0f,
+
+      1.0f, 1.0f,
+      0.0f, 1.0f,
+      0.0f, 0.0f,
+
+      1.0f, 1.0f,
+      0.0f, 1.0f,
+      0.0f, 0.0f,
+
+      1.0f, 1.0f,
+      0.0f, 1.0f,
+      0.0f, 0.0f,
+
+      1.0f, 1.0f,
+      0.0f, 1.0f,
+      0.0f, 0.0f,
+      1.0f, 1.0f,
+      0.0f, 0.0f,
+      1.0f, 0.0f,
+
+      1.0f, 1.0f,
+      0.0f, 1.0f,
+      0.0f, 0.0f,
+      1.0f, 1.0f,
+      0.0f, 0.0f,
+      1.0f, 0.0f,
+
+      1.0f, 1.0f,
+      0.0f, 1.0f,
+      0.0f, 0.0f,
+      1.0f, 1.0f,
+      0.0f, 0.0f,
+      1.0f, 0.0f,
+
+      1.0f, 1.0f,
+      0.0f, 1.0f,
+      0.0f, 0.0f,
+      1.0f, 1.0f,
+      0.0f, 0.0f,
+      1.0f, 0.0f,
+
+      1.0f, 1.0f,
+      0.0f, 1.0f,
+      0.0f, 0.0f,
 
       1.0f, 1.0f,
@@ -687,6 +919,6 @@
 
    T_model = translate(mat4(), vec3(0.0f, -0.9f, 0.0f));
-   R_model = rotate(mat4(), -1.0f, vec3(1.0f, 0.0f, 0.0f));
-   obj.model_base = T_model; //T_model * R_model;
+   R_model = rotate(mat4(), 0.6f, vec3(1.0f, 0.0f, 0.0f));
+   obj.model_base = T_model * R_model * scale(mat4(), vec3(0.3f, 0.3f, 0.3f));;
 
    addObjectToScene(obj);
@@ -964,5 +1196,5 @@
          view_mat = R*T;
 
-         printVector("cam pos", cam_pos);
+         //printVector("cam pos", cam_pos);
 
          glUseProgram(color_sp);